------------------------------------------------------------------------
-- Some example(s) of bad usage of the library
------------------------------------------------------------------------

module Bad where

open import Thunk
open import Data.Bool
open import Data.Nat
open import Data.Nat.Properties
open ℕ-semiringSolver
open import Data.Fin
open import Data.Vec hiding (_>>=_)
open import Relation.Binary.PropositionalEquality

------------------------------------------------------------------------
-- Some lemma(s)

abstract

  lem₁ : forall n -> 1 + (2 * n) + 1 ≡ 2 * (1 + n)
  lem₁ n = prove (n ∷ [])
                 (con 1 :+ (con 2 :* N) :+ con 1)
                 (con 2 :* (con 1 :+ N))
                 ≡-refl
    where N = var zero

------------------------------------------------------------------------
-- Ticks are necessary on anonymous lambdas

-- Note that the result of forcing "adder n" is a function which adds
-- n to its argument. This function takes only one step to compute,
-- according to the type signature of adder. This is clearly wrong.
-- The reason for this discrepancy is that one tick has been omitted
-- in adder, that on the anonymous lambda in the last return.

adder : (n : ℕ) -> Thunk (1 + 2 * n) (ℕ -> Thunk 1 ℕ)
adder zero    = √ return (\n -> √ return n)
adder (suc n) = √
  cast (lem₁ n)
  (adder n >>= \f -> √
   (return (\n -> f (suc n))))
