module MonolithicList where

open import Thunk hiding (_[_])
open import Data.List
open import Data.Nat
open import Data.Nat.Properties
open ℕ-semiringSolver
open import Data.Vec hiding (_>>=_) renaming (_∷_ to cons; [] to nil)
open import Data.Fin
open import Relation.Binary.PropositionalEquality

------------------------------------------------------------------------
-- Some boring lemmas

abstract

  lem₁ : forall m -> (1 + 2 * m) + 1 ≡ 2 * (1 + m)
  lem₁ m = prove (cons m nil)
                 ((con 1 :+ con 2 :* M) :+ con 1)
                 (con 2 :* (con 1 :+ M))
                 ≡-refl
    where M = var zero

------------------------------------------------------------------------
-- More interesting functions

infixr 5 _++√_

_++√_ : forall {a} -> (xs ys : [ a ]) -> Thunk (1 + 2 * length xs) [ a ]
[]       ++√ ys = √ return ys
(x ∷ xs) ++√ ys = √
  cast (lem₁ (length xs))
    (xs ++√ ys >>= \xsys -> √
     return (x ∷ xsys))
