-- # import monoid
-- # import eq

-- Why aren't the hidden parameters hidden within signature
-- definitions? This is unreadable. Some way to avoid the substs
-- (perhaps through rewrites) would also be nice.

sig Monad (m : Set -> Set) : Type where
  bind (a₁, a₂ : Set) : m a₁ -> (a₁ -> m a₂) -> m a₂
  return (a₀ : Set) : a₀ -> m a₀

  leftUnit (a₁, a₂ : Set)
    :  (x : a₁) -> (f : a₁ -> m a₂)
    -> bind a₁ a₂ (return a₁ x) f ≡ f x
  rightUnit (a₁ : Set)
    :  (c : m a₁)
    -> bind a₁ a₁ c (return a₁) ≡ c
  assoc (a₁, a₂, a₃ : Set)
    :  (c : m a₁) -> (f : a₁ -> m a₂) -> (g : a₂ -> m a₃)
    -> bind a₂ a₃ (bind a₁ a₂ c f) g ≡
       bind a₁ a₃ c (\x -> bind a₂ a₃ (f x) g)

sig AnnotatedMonad
      {a : Set}
      (p : Monoid a)
      (m : a -> Set -> Set)
        : Type where
  bind (n₁, n₂ : a) (b₁, b₂ : Set)
    : m n₁ b₁ -> (b₁ -> m n₂ b₂) -> m (p.(+) n₁ n₂) b₂
  return (b : Set) : b -> m p.zero b

  leftUnit (n₁ : a) (a₁, a₂ : Set)
    :  (x : a₁) -> (f : a₁ -> m n₁ a₂)
    -> subst (\n -> m n a₂) p.leftUnit
             (bind p.zero n₁ a₁ a₂ (return a₁ x) f) ≡
       f x
  rightUnit (n₁ : a) (a₁ : Set)
    :  (c : m n₁ a₁)
    -> subst (\n -> m n a₁) p.rightUnit
             (bind n₁ p.zero a₁ a₁ c (return a₁)) ≡
       c
  assoc (n₁, n₂, n₃ : a) (a₁, a₂, a₃ : Set)
    :  (c : m n₁ a₁) -> (f : a₁ -> m n₂ a₂) -> (g : a₂ -> m n₃ a₃)
    -> bind (p.(+) n₁ n₂) n₃ a₂ a₃ (bind n₁ n₂ a₁ a₂ c f) g ≡
       subst (\n -> m n a₃) p.assoc
             (bind n₁ (p.(+) n₂ n₃) a₁ a₃
                   c (\x -> bind n₂ n₃ a₂ a₃ (f x) g)
             )
