------------------------------------------------------------------------
-- Heaps
------------------------------------------------------------------------

open import TypeSystem

module Heap (_•_ : TmLike) where

open import Kind

infixl 20 _▷ʰ_

data Heap {k : Kind} : Ctxt k -> Set where
  ∅ʰ   : Heap ε
  _▷ʰ_ : forall {Γ τ} -> Heap Γ -> Γ • τ -> Heap (Γ ▻ τ)

-- Note that Heap Γ ≇ Γ ⇒ ε; if that were the case the _▷ʰ_
-- constructor would have type
--
--   _▷ʰ_ : forall {Γ τ} -> Heap Γ -> ε • τ -> Heap (Γ ▻ τ),
--
-- i.e. all elements in the heap would have to be closed.
